public class Roomies {
    // ================ STUDENT CODE BELOW HERE: ================
    // Finds -- out of all other available people that would be the best
    // (i.e, highest affinity) - the Person to be matched as a roommate
    // to Person p.
    public static Person findBestMatch(Person p, Person[] list) {
        Person bestMatch = null;
        int bestAffinity = -100;
        for (Person o : list) {
            if (p.equals(o) || !o.isAvailable())
                continue;
            int affinity = p.affinity(o);
            if (affinity > bestAffinity) {
                bestAffinity = affinity;
                bestMatch = o;
            }
        }
        return bestMatch;  // Replace with your solution
    }

    // Creates a match between two Persons by setting their availability to false.
    // It then returns a String containing both persons and their affinity score,
    // using the format “<p1> and <p2> : <affinity>”:
    public static String makeMatch(Person p1, Person p2) {
        p1.setStatus(false);
        p2.setStatus(false);
        return p1 + " and " + p2 + " : " + p1.affinity(p2);  // Replace with your solution
    }


    //
    public static String makeBestMatches(Person[] list) {
        StringBuilder sb = new StringBuilder();
        for (Person p : list) {
            if (!p.isAvailable())
                continue;
            Person o = findBestMatch(p, list);
            sb.append("\n" + makeMatch(p, o));
        }
        return sb.substring(1);  // Replace with your solution
    }

    // =================== STUDENT CODE ABOVE  ==================

    // ================ DO NOT MODIFY THE CODE BELOW HERE: ================
    // returns an array of People objects read from standard input
    private static Person[] readPeople() {
        int nPeople = StdIn.readInt();
        Person[] people = new Person[nPeople];
        for (int i = 0; i < nPeople; i++) {
            String name = StdIn.readString();
            int wake = StdIn.readInt();
            String music = StdIn.readString();
            String personality = StdIn.readString();
            people[i] = new Person(name, wake, music, personality);
        }
        return people;
    }

    // Tests this class
    public static void main(String[] args) {
        Person[] people = readPeople();
        StdOut.println(makeBestMatches(people));
    }
}
